const Path = require('path');
const TsConfigPathsPlugin = require('awesome-typescript-loader').TsConfigPathsPlugin;
const packages = require('../../package.json');
 
module.exports = { 
    target: 'web',
    entry: {
        app: [
            Path.resolve(__dirname, '../../src/ts/@overflow/app/index.tsx')
        ],
        vendor: Object.keys(packages.dependencies)
    },
 
    output: {
        path: Path.resolve(__dirname, '../../dist'),
        filename: '[name].js',
        publicPath: '/'
    },
 
    devtool: '',
 
    resolve: {
        extensions: ['.ts', '.tsx', '.js', '.json'],
        plugins: [
            new TsConfigPathsPlugin({
                tsconfig: "tsconfig.json",
                compiler: "typescript"
            })
        ]
    },
 
    module: {
        rules: [
            {
                test: /\.tsx?$/,
                enforce: 'pre',
                exclude: [
                    Path.resolve(__dirname, '../../node_modules/')
                ],
                loader: 'tslint-loader',
            }
        ]
    },
    plugins: [
    ],
    node: {
        fs: 'empty'
    }
};
