import Action from '@overflow/commons/redux/Action';
import ApiKey from '../..//api/model/ApiKey';
import Domain from '@overflow/domain/api/model/Domain';

import ReadPayload from '../payload/ReadPayload';

// Action Type
export type REQUEST = '@overflow/apikey/read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/apikey/read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/apikey/read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/apikey/read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/apikey/read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/apikey/read/REQUEST_FAILURE';

// Action Creater
export type request = (domain: Domain) => Action<ReadPayload>;
export type requestSuccess = (apiKey: ApiKey) => Action<ApiKey>;
export type requestFailure = (error: Error) => Action;



export const request: request = (domain: Domain): Action<ReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        domain:domain,
      },
    };
};

export const requestSuccess: requestSuccess = (apiKey: ApiKey): Action<ApiKey> => {
  return {
      type: REQUEST_SUCCESS,
      payload: apiKey,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
