import Action from '@overflow/commons/redux/Action';
import ApiKey from '../..//api/model/ApiKey';

import RegistPayload from '../payload/RegistPayload';

// Action Type
export type REQUEST = '@overflow/apikey/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/apikey/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/apikey/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/apikey/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/apikey/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/apikey/regist/REQUEST_FAILURE';

// Action Creater
export type request = (ApiKey: ApiKey) => Action<RegistPayload>;
export type requestSuccess = (apiKey: ApiKey) => Action<ApiKey>;
export type requestFailure = (error: Error) => Action;



export const request: request = (apiKey: ApiKey): Action<RegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        apiKey:apiKey,
      },
    };
};

export const requestSuccess: requestSuccess = (apiKey: ApiKey): Action<ApiKey> => {
  return {
      type: REQUEST_SUCCESS,
      payload: apiKey,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
