import * as React from 'react';
import { Route, RouteProps, Switch } from 'react-router-dom';

import SignIn from '../views/member/SignIn';
import SignUp from '../views/member/SignUp';
import PWChange from '../views/member/ForgotPassword';
import SensorList from '../views/monitoring/sensor/List';
import SensorSetup from '../views/monitoring/sensor/Setup';
import ProbeList from '../views/monitoring/probe/List';
import TargetList from '../views/infrastructure/target/List';
import Discovery from '../../temp/react/components/Discovery';

// import { SignUp } from '@overflow/member/react/components/SignUp';
// import { SignIn } from '@overflow/member/react/components/SignIn';
// import { PWChange } from '@overflow/member/react/components/PWChange';
// import { ProbeDown } from '@overflow/temp/react/components/ProbeDown';
// import { DiscoveryDetails } from '@overflow/temp/react/components/DiscoveryDetails';
// import { Components } from '@overflow/temp/react/components/Components';
// import { Sensors } from '@overflow/temp/react/components/Sensors';
// import { Layout } from './containers/test/layout/Layout'
// import { Tree } from '@overflow/temp/react/components/commons/Tree';
import { TableExampleSortable } from '@overflow/temp/react/components/TableExampleSortable';

import Home from '../views/Home';

interface AppRouter extends RouteProps {

}

const routeConfig: AppRouter[] = [
    {
        path: '/',
        component: Home,
    },
];


const routes = (
    <Switch>
        {/*<Route exact path='/'/>
        <Route exact path='/test2' component={SignUp} />
          <Route exact path='/test3' component={SignIn} />
          <Route exact path='/test4' component={PWChange} />
          <Route exact path='/test5' component={ProbeDown} />
          <Route exact path='/test6' component={DiscoveryDetails} />
          <Route exact path='/test7' component={Tree} />
          <Route exact path='/test8' component={TableExampleSortable} />

          <Route exact path='/test14' component={Components} />

          <Route exact path='/test21' component={Sensors} />*/}
        {/*<Route path='/sensorList' component={SensorList} />*/}
        <Route exact path='/test2' component={SignUp} />
        <Route exact path='/test3' component={SignIn} />
        <Route exact path='/test4' component={PWChange} />
        <Route exact path='/test24' component={Discovery} />

        <Route exact path='/probes' component={ProbeList} />
        <Route exact path='/sensor_list' component={SensorList} />
        <Route exact path='/target_list' component={TargetList} />
        <Route exact path='/sensor_setup' component={SensorSetup} />


    </Switch>

);

export default routes;

// const _routes = [
//   {
//     path: '/signin',
//     exact: true,
//     component: Signin,
//   },
//   {
//     path: '/signup',
//     exact: true,
//     component: Signup,
//   },
//   {
//     path: '/forgot_password',
//     exact: true,
//     component: ForgotPassword,
//   },
//   {
//     path: '/email_confirm',
//     exact: true,
//     component: EmailConfirm,
//   },
//   {
//     path: '/',
//     exact: true,
//     component: Home,
//     routes: [
//       {
//         path: '/monitoring',
//         component: Monitoring,
//         routes: [
//             {
//                 path: '/probe',
//                 component: Probe,
//                 routes: [
//                     {
//                         path: '/list',
//                         component: Probe,
//                     },
//                     {
//                         path: '/noauth',
//                         component: NoAuthProbe,
//                     },
//                     {
//                         path: '/setup',
//                         component: ProbeSetup,
//                     },
//                 ],
//             },
//             {
//                 path: '/sensor',
//                 component: Sensor,
//             },
//         ],
//       },
//       {
//         path: '/infrastructure',
//         component: ,
//         routes: [
//             {
//                 path: '/maps',
//                 component: InfrastructureMaps,
//             },
//             {
//                 path: '/targets',
//                 component: Targets,
//             },
//         ],
//       },
//       {
//         path: '/dashboard',
//         component: Dashboard,
//       },
//       {
//         path: '/metrics',
//         component: Metrics,
//       },
//       {
//         path: '/alerts',
//         component: Alerts,
//       },
//       {
//         path: '/history',
//         component: History,
//       },
//       {
//         path: '/settings',
//         component: Settings,
//       },
//       {
//         path: '/notifications',
//         component: Notifications,
//       },
//       {
//         path: '/account',
//         component: ,
//         routes: [
//             {
//                 path: '/signout',
//                 component: Signout,
//             },
//             {
//                 path: '/profile',
//                 component: Profile,
//             },
//             {
//                 path: '/preferences',
//                 component: Preferences,
//             },
//             {
//                 path: '/help',
//                 component: Help,
//             },
//         ],
//       },
//     ],
//   },
// ];
