import * as React from 'react';
import { RouteComponentProps, RouteProps, Route, Switch } from 'react-router-dom';
import {
  Header,
  Grid,
  Image,
  Segment,
} from 'semantic-ui-react';

import SignIn from '../member/SignIn';
import SignUp from '../member/SignUp';
import EmailConfirm from '../member/EmailConfirm';
import ForgotPassword from '../member/ForgotPassword';
import PWConfirm from '../member/PWConfirm';
import Modify from '../member/Modify';

export interface Props extends RouteComponentProps<any> {
}
export interface State {
}

class AccountLayout extends React.Component<Props, State> {

  public constructor(props?: Props, context?: State) {
    super(props, context);

  }

  public render(): JSX.Element {
    return (
      <Grid textAlign='center' className='fullHeight' verticalAlign='middle' style={{background:'#1a1b37', margin:'0'}}>
        <Grid.Column style={{ maxWidth: 450 }}>
          <Header as='h2' color='teal' textAlign='center'>
            <Image src='../asset/image/overFlow_CI_blue_180.png' /><br />
            {' '}Log-in to your account
          </Header>
          <Segment raised style={{paddingBottom:'0px'}}>
            <Switch>
              <Route path={`${this.props.match.url}/signin`} component={SignIn}/>
              <Route path={`${this.props.match.url}/signup`} component={SignUp}/>
              <Route path={`${this.props.match.url}/pw_confirm`} component={PWConfirm}/>
              <Route path={`${this.props.match.url}/check_email`} component={EmailConfirm}/>
              <Route path={`${this.props.match.url}/forgot_password`} component={ForgotPassword}/>
              <Route path={`${this.props.match.url}/modify`} component={Modify}/>
            </Switch>
          </Segment>
        </Grid.Column>
      </Grid>
    );
  }

}


export default AccountLayout;
