import * as React from 'react';
import { Redirect, RouteComponentProps, RouteProps, Route, Switch } from 'react-router-dom';
import { Container, Segment } from 'semantic-ui-react';
import { Header } from './Header';
import { Footer } from './Footer';
import LeftMenu from './LeftMenu';

import Home from '../Home';
import ProbeList from '../../views/monitoring/probe/List';
import TargetList from '../../views/infrastructure/target/List';
import SensorList from '../monitoring/sensor/List';
import NoauthList from '../../views/monitoring/probe/NoAuth';
import ProbeSetup from '../../views/monitoring/probe/Setup';
import HistoryList from '../../views/history/List';
import TitleBarContainer from '@overflow/app/views/layout/TitleBarContainer';

export interface Props extends RouteComponentProps<any> {
}
export interface State {
}

export class AppLayout extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
    };
  }


  public render(): JSX.Element {
    return (
      <Container fluid>
        <LeftMenu />
        <Segment basic style={{ margin: '0 0 0 210px', padding: '0' }}>
          <Header />
          <TitleBarContainer location={this.props.location.pathname}/>
            <Segment basic>
              <Switch>
                <Route exact={true} path={`${this.props.match.url}`} component={Home}/>
                <Route exact={true} path={`${this.props.match.url}probes`} component={ProbeList}/>
                <Route exact={true} path={`${this.props.match.url}targets`} component={TargetList}/>
                <Route exact={true} path={`${this.props.match.url}sensors`} component={SensorList}/>
                <Route exact={true} path={`${this.props.match.url}noauth_probes`} component={NoauthList}/>
                <Route exact={true} path={`${this.props.match.url}probe_setup`} component={ProbeSetup}/>
                <Route exact={true} path={`${this.props.match.url}histories`} component={HistoryList}/>
                <Redirect to='/error/404' />
              </Switch>
            </Segment>
          <Footer />
        </Segment>
      </Container >
    );
  }
}

export default AppLayout;

