import * as React from 'react';
import { connect, Dispatch } from 'react-redux';
import { push as routerPush } from 'react-router-redux';

import { Menu, Dropdown, Icon, Header, Image } from 'semantic-ui-react';

export interface StateProps {
}

export interface DispatchProps {
  onChangeUrl?(url: string): void;
}

export type Props = StateProps & DispatchProps;

export interface State {
}

class LeftMenu extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
    };

    window.addEventListener('resize', () => {
      console.log(window);
    });
  }



  public render(): JSX.Element {
    return (
      <Menu fixed='left' inverted vertical borderless>
        <Menu.Item name='User'>
          <Header textAlign='center'>
            <Image src='http://glia.ca/scm/2013/ge1127_b/wp-content/uploads/2013/10/594partner-profile-pic-An.jpg'
              size='mini' shape='circular' href='/' />
          </Header>
        </Menu.Item>
        <Menu.Item name='Home' href='/' >
          <Header inverted sub icon='home' content='Home' />
        </Menu.Item>

        <Menu.Item>
          <Menu.Header name='Monitoring' >
            <Header inverted sub icon='bar graph' content='Monitoring' />
          </Menu.Header>
          <Menu.Menu>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/probes')} style={{ 'marginLeft': '30px' }}>
              Probe
            </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/noauth_probes')} style={{ 'marginLeft': '30px' }}>
              NoauthProbe
            </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/probe_setup')} style={{ 'marginLeft': '30px' }}>
              Probe Setup
            </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/sensors')} style={{ 'marginLeft': '30px' }}>
              Sensors
            </Menu.Item>
          </Menu.Menu>
        </Menu.Item>

        <Menu.Item>
          <Menu.Header name='Infrastructure' >
            <Header inverted sub icon='sitemap' content='Infrastructure' />
          </Menu.Header>
          <Menu.Menu>
            <Menu.Item href='#/' style={{ 'marginLeft': '30px' }}>Maps</Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/targets')} style={{ 'marginLeft': '30px' }}>Targets</Menu.Item>
          </Menu.Menu>
        </Menu.Item>

        <Menu.Item name='Dashboard' href='/' >
          <Header inverted sub icon='industry' content='Dashboard' />
        </Menu.Item>

        <Menu.Item name='Metrics' href='/'>
          <Header inverted sub icon='tasks' content='Metrics' />
        </Menu.Item>

        <Menu.Item name='Alerts' onClick={(e) => this.props.onChangeUrl('/temp/discovery')}>
          <Header inverted sub icon='alarm' content='Alerts' />
        </Menu.Item>

        <Menu.Item name='History' onClick={(e) => this.props.onChangeUrl('/histories')} >
          <Header inverted sub icon='book' content='History' />
        </Menu.Item>


        <Menu.Item name='Custom'>
          <Header inverted sub><Icon name='play circle' />
            <Header.Content>
              <Dropdown text='Custom'>
                <Dropdown.Menu>
                  <Dropdown.Header>Custom</Dropdown.Header>
                  <Dropdown.Item href='#/temp/tablesort'>TableSortView</Dropdown.Item>
                  <Dropdown.Item href='#/sensor_list'>SensorList</Dropdown.Item>
                  <Dropdown.Item href='#/sensor_setup'>SensorSetup</Dropdown.Item>
                </Dropdown.Menu>
              </Dropdown>
            </Header.Content>
          </Header>
        </Menu.Item>

        <Menu.Item name='Settings' href='/' >
          <Header inverted sub icon='setting' content='Settings' />
        </Menu.Item>

        <Menu.Item>
          <Menu.Header name='Account' >
            <Header inverted sub icon='user' content='Account' />
          </Menu.Header>
          <Menu.Menu>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/account/signin')} style={{ 'marginLeft': '30px' }}>
              Sign In
              </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/account/signup')} style={{ 'marginLeft': '30px' }}>
              Sign Up
              </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/account/pw_confirm')} style={{ 'marginLeft': '30px' }}>
              PW Confirm
            </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/account/modify')} style={{ 'marginLeft': '30px' }}>
              Modify
            </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/account/logout')} style={{ 'marginLeft': '30px' }}>
              Log Out
            </Menu.Item>
            <Menu.Item onClick={(e) => this.props.onChangeUrl('/temp/discoveryTree')} style={{ 'marginLeft': '30px' }}>
              Discovery Tree
            </Menu.Item>
          </Menu.Menu>
        </Menu.Item>
      </Menu>

    );
  }
}


export function mapStateToProps(state: any): StateProps {
  return {

  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
  return {
    onChangeUrl: (url: string): void => {
      dispatch(routerPush(url));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(LeftMenu);
