import Action from '@overflow/commons/redux/Action';
import AsyncRequestPayload from '../payload/AsyncRequestPayload';

// Action Type
export type REQUEST = '@overflow/commons/anync/REQUEST';
export const REQUEST: REQUEST = '@overflow/commons/anync/REQUEST';

// Action Creater
export type request = (service: string, method: string, requestType: string, ...args: any[]) => Action<AsyncRequestPayload>;
export type requestSuccess = (requestType: string, result: any) => Action<any>;
export type requestFailure = (requestType: string, error: any) => Action<any>;

export const request: request = (service: string, method: string, requestType: string, ...args: any[]): Action<AsyncRequestPayload> => {
  return {
      type: REQUEST,
      payload: {
        service: service,
        method: method,
        requestType: requestType,
        args: args,
      },
    };
};

export const requestSuccess: requestSuccess = (requestType: string, result: any): Action<any> => {
  return {
      type: `${requestType}/SUCCESS`,
      payload: result,
    };
};

export const requestFailure: requestFailure = (requestType: string, error: Error): Action<any> => {
  return {
      type: `${requestType}/FAILURE`,
      error: error,
    };
};
