import Header from './Header';

export class Notification extends Header {
  private readonly method: string;
  private readonly params: any;

  public constructor(method: string, params?: any) {
    super();
    this.method = method;
    this.params = params;
  }

  /**
   * get Method
   */
  public get Method(): string {
    return this.method;
  }

  /**
   * get Params
   */
  public get Params(): any {
    return this.params;
  }

  public static convert(notification: Notification): Notification {
    const method = notification.method;
    if (undefined === method) {
      throw new Error(`Notification must include method`);
    }
    const params = notification.params;

    return new Notification(method, params);
  }

}

export default Notification;
