import { connect, Dispatch } from 'react-redux';
import {
  Discovery,
  StateProps as DiscoveryStateProps,
  DispatchProps as DiscoveryDispatchProps,
} from './components/Discovery';

import Host from '@overflow/discovery/api/model/Host';
import Probe from '@overflow/probe/api/model/Probe';

import * as InfraTargetRegistAllActionTypes from '../redux/action/infra_target_regist_all';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

export function mapStateToProps(state: any, props: any): DiscoveryStateProps {
  return {
    // probeId: props.probeId,
    isSuccess: state.isSuccess,
    // onRefreshList: props.onRefreshList,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DiscoveryDispatchProps {
  return {
    onCreateTarget: (hosts: Host[], probe: Probe) => {
      console.log('hosts size : ' + JSON.stringify(hosts).length);
      dispatch(asyncRequestActions.request('TargetDiscoveryService', 'saveAllTarget',
                                           InfraTargetRegistAllActionTypes.REQUEST, JSON.stringify(hosts), JSON.stringify(probe)));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(Discovery);
