import * as React from 'react';
import {
  Table,
  Label,
  Header,
  Container,
  Icon,
} from 'semantic-ui-react';
import {object} from 'prop-types';

export interface Props {
  probe?: any;
  onProbeChange?:((obj:object) => void);
}

export interface State {
}

export class DiscoveryProbe extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {};
  }

  // public componentWillMount():void {
  //   super.componentWillMount();
  //   console.log(this.props.probe);
  // }

  public handle():void {
    this.props.onProbeChange(this.state);
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Header as='h4' color='grey'> Probe</Header>
        <Table celled={false}>
          <Table.Body>
            <Table.Row>
              <Table.Cell width={4} collapsing>
                <Header size='small'>Domain</Header>
              </Table.Cell>
              <Table.Cell width={12}>{this.props.probe.domain.name}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Status</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.metaProbeStatus.name}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Host IP</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.host.ip}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Host Name</Header>
              </Table.Cell>
              <Table.Cell>Geek`s Ubuntu</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Authorized at</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.createAt}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Description</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.description}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Last polling at</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.lastPollingAt}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Next polling at</Header>
              </Table.Cell>
              <Table.Cell>{this.props.probe.nextPollingAt}</Table.Cell>
            </Table.Row>
          </Table.Body>
        </Table>

      </Container>
    );
  }

}
