import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';


import * as InfraTargetRegistAllActionTypes from '../action/infra_target_regist_all';
import InfraTargetRegistAllState, { defaultState as infraTargetRegistAllDefaultState } from '../state/InfraTargetRegistAll';

const reducer: ReducersMapObject = {
  [InfraTargetRegistAllActionTypes.REQUEST_SUCCESS]: (state: InfraTargetRegistAllState = infraTargetRegistAllDefaultState,
                                                      action: Action<boolean>): InfraTargetRegistAllState => {
    return {
      ...state,
      isSuccess: action.payload,
    };
  },
  [InfraTargetRegistAllActionTypes.REQUEST_FAILURE]: (state: InfraTargetRegistAllState = infraTargetRegistAllDefaultState,
                                                      action: Action<Error>): InfraTargetRegistAllState => {
    return {
      ...state,
      error: action.error,
    };
  },
};

export default reducer;
