import Action from '@overflow/commons/redux/Action';
import DomainMember from '@overflow/domain/api/model/DomainMember';

import MemberRegistPayload from '../payload/MemberRegistPayload';

// Action Type
export type REQUEST = '@overflow/domain/member_regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/domain/member_regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/domain/member_regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/domain/member_regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/domain/member_regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/domain/member_regist/REQUEST_FAILURE';

// Action Creater
export type request = (domain: DomainMember) => Action<MemberRegistPayload>;
export type requestSuccess = () => Action<void>;
export type requestFailure = (error: Error) => Action;

export const request: request = (domainMember: DomainMember): Action<MemberRegistPayload> => {
  return {
    type: REQUEST,
    payload: {
      domainMember: domainMember,
    },
  };
};

export const requestSuccess: requestSuccess = (): Action<void> => {
  return {
    type: REQUEST_SUCCESS,
    payload: null,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
