import Action from '@overflow/commons/redux/Action';
import Domain from '@overflow/domain/api/model/Domain';

import RegistPayload from '../payload/RegistPayload';

// Action Type
export type REQUEST = '@overflow/domain/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/domain/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/domain/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/domain/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/domain/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/domain/regist/REQUEST_FAILURE';

// Action Creater
export type request = (domain: Domain) => Action<RegistPayload>;
export type requestSuccess = () => Action<void>;
export type requestFailure = (error: Error) => Action;

export const request: request = (domain: Domain): Action<RegistPayload> => {
  return {
    type: REQUEST,
    payload: {
      domain: domain,
    },
  };
};

export const requestSuccess: requestSuccess = (): Action<void> => {
  return {
    type: REQUEST_SUCCESS,
    payload: null,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
