/**
 * Created by geek on 17. 7. 4.
 */
import Action from '@overflow/commons/redux/Action';
import EmailAuth from '@overflow/email/api/model/EmailAuth';

import ModifyPayload from '../payload/ModifyPayload';

// Action Type
export type REQUEST = '@overflow/email/modify/REQUEST';
export type REQUEST_SUCCESS = '@overflow/email/modify/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/email/modify/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/email/modify/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/email/modify/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/email/modify/REQUEST_FAILURE';

// Action Creater
export type request = (emailAuth:EmailAuth) => Action<ModifyPayload>;
export type requestSuccess = (emailAuth: EmailAuth) => Action<EmailAuth>;
export type requestFailure = (error: Error) => Action;

export const request: request = (emailAuth:EmailAuth): Action<ModifyPayload> => {
  return {
    type: REQUEST,
    payload: {
      emailAuth: emailAuth,
    },
  };
};

export const requestSuccess: requestSuccess = (emailAuth: EmailAuth): Action<EmailAuth> => {
  return {
    type: REQUEST_SUCCESS,
    payload: emailAuth,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};

