import Action from '@overflow/commons/redux/Action';
import EmailAuth from '@overflow/email/api/model/EmailAuth';

import ReadPayload from '../payload/ReadPayload';

// Action Type
export type REQUEST = '@overflow/email/read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/email/read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/email/read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/email/read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/email/read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/email/read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<ReadPayload>;
export type requestSuccess = (emailAuth: EmailAuth) => Action<EmailAuth>;
export type requestFailure = (error: Error) => Action;

export const request: request = (id: number): Action<ReadPayload> => {
  return {
    type: REQUEST,
    payload: {
      id: id,
    },
  };
};

export const requestSuccess: requestSuccess = (emailAuth: EmailAuth): Action<EmailAuth> => {
  return {
    type: REQUEST_SUCCESS,
    payload: emailAuth,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};

