import Action from '@overflow/commons/redux/Action';
import EmailAuth from '@overflow/email/api/model/EmailAuth';

import ReadByMemberPayload from '../payload/ReadByMemberPayload';

// Action Type
export type REQUEST = '@overflow/email/read_by_member/REQUEST';
export type REQUEST_SUCCESS = '@overflow/email/read_by_member/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/email/read_by_member/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/email/read_by_member/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/email/read_by_member/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/email/read_by_member/REQUEST_FAILURE';

// Action Creater
export type request = (memberId: number) => Action<ReadByMemberPayload>;
export type requestSuccess = (emailAuths: EmailAuth[]) => Action<EmailAuth[]>;
export type requestFailure = (error: Error) => Action;

export const request: request = (memberId: number): Action<ReadByMemberPayload> => {
  return {
    type: REQUEST,
    payload: {
      memberId: memberId,
    },
  };
};

export const requestSuccess: requestSuccess = (emailAuths: EmailAuth[]): Action<EmailAuth[]> => {
  return {
    type: REQUEST_SUCCESS,
    payload: emailAuths,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
