import Action from '@overflow/commons/redux/Action';
import EmailAuth from '@overflow/email/api/model/EmailAuth';

import SendEmailPayload from '../payload/SendEmailByMemberPayload';

// Action Type
export type REQUEST = '@overflow/email/send_email_by_member/REQUEST';
export type REQUEST_SUCCESS = '@overflow/email/send_email_by_member/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/email/send_email_by_member/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/email/send_email_by_member/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/email/send_email_by_member/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/email/send_email_by_member/REQUEST_FAILURE';

// Action Creater
export type request = (memberId: number, email: string) => Action<SendEmailPayload>;
export type requestSuccess = (emailAuth: EmailAuth) => Action<EmailAuth>;
export type requestFailure = (error: Error) => Action;

export const request: request = (memberId: number, email: string): Action<SendEmailPayload> => {
  return {
    type: REQUEST,
    payload: {
      memberId: memberId,
      email: email,
    },
  };
};

export const requestSuccess: requestSuccess = (emailAuth: EmailAuth): Action<EmailAuth> => {
  return {
    type: REQUEST_SUCCESS,
    payload: emailAuth,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};

