import { connect, Dispatch } from 'react-redux';
import {
  HistoryList,
  StateProps as HistoryStateProps,
  DispatchProps as HistoryDispatchProps,
  Props as SignInProps,
} from './components/HistoryList';
import { push as routerPush } from 'react-router-redux';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
import Probe from '@overflow/probe/api/model/Probe';
import * as readAllByProbeActions from '../redux/action/read_all_by_probe';

export function mapStateToProps(state: any, ownProps?: any): HistoryStateProps {
  return {
    probeId: '1',
    histories: state.historyPage,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>, ownProps?: any): HistoryDispatchProps {
  return {
    onReadAllByProbe: (probe: Probe, pageNo: string, countPerPage: string) => {
      dispatch(asyncRequestActions.request('HistoryService', 'readAllByProbe', readAllByProbeActions.REQUEST,
                                           JSON.stringify(probe), pageNo, countPerPage));
    },
    // onRedirectHome: () => {
    //   dispatch(routerPush('/'));
    // },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(HistoryList);
