import Action from '@overflow/commons/redux/Action';
import InfraHost from '../..//api/model/InfraHost';

import HostRegistPayload from '../payload/HostRegistPayload';

// Action Type
export type REQUEST = '@overflow/infra/host_regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/host_regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/host_regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/host_regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/host_regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/host_regist/REQUEST_FAILURE';

// Action Creater
export type request = (infraHost: InfraHost) => Action<HostRegistPayload>;
export type requestSuccess = (infraHost: InfraHost) => Action<InfraHost>;
export type requestFailure = (error: Error) => Action;



export const request: request = (infraHost: InfraHost): Action<HostRegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        infraHost:infraHost,
      },
    };
};

export const requestSuccess: requestSuccess = (infraHost: InfraHost): Action<InfraHost> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraHost,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
