import Action from '@overflow/commons/redux/Action';
import InfraMachine from '../..//api/model/InfraMachine';

import MachineRegistPayload from '../payload/MachineRegistPayload';

// Action Type
export type REQUEST = '@overflow/infra/machine_regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/machine_regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/machine_regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/machine_regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/machine_regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/machine_regist/REQUEST_FAILURE';

// Action Creater
export type request = (infraMachine: InfraMachine) => Action<MachineRegistPayload>;
export type requestSuccess = (infraMachine: InfraMachine) => Action<InfraMachine>;
export type requestFailure = (error: Error) => Action;



export const request: request = (infraMachine: InfraMachine): Action<MachineRegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        infraMachine:infraMachine,
      },
    };
};

export const requestSuccess: requestSuccess = (infraMachine: InfraMachine): Action<InfraMachine> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraMachine,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
