import Action from '@overflow/commons/redux/Action';
import InfraOS from '../..//api/model/InfraOS';

import OSRegistPayload from '../payload/OSRegistPayload';

// Action Type
export type REQUEST = '@overflow/infra/os_regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/os_regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/os_regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/os_regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/os_regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/os_regist/REQUEST_FAILURE';

// Action Creater
export type request = (infraOS: InfraOS) => Action<OSRegistPayload>;
export type requestSuccess = (infraOS: InfraOS) => Action<InfraOS>;
export type requestFailure = (error: Error) => Action;



export const request: request = (infraOS: InfraOS): Action<OSRegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        infraOS:infraOS,
      },
    };
};

export const requestSuccess: requestSuccess = (infraOS: InfraOS): Action<InfraOS> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraOS,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
