import Action from '@overflow/commons/redux/Action';
import Infra from '../..//api/model/Infra';

import RegistPayload from '../payload/RegistPayload';

// Action Type
export type REQUEST = '@overflow/infra/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/regist/REQUEST_FAILURE';

// Action Creater
export type request = (infra: Infra) => Action<RegistPayload>;
export type requestSuccess = (infra: Infra) => Action<Infra>;
export type requestFailure = (error: Error) => Action;



export const request: request = (infra: Infra): Action<RegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        infra:infra,
      },
    };
};

export const requestSuccess: requestSuccess = (infra: Infra): Action<Infra> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infra,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
