import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import InfraHost from '@overflow/infra/api/model/InfraHost';

import * as actionType from '../action/host_read';
import ReadHostState, { defaultState as ReadHostDefaultState } from '../state/HostRead';

const reducer: ReducersMapObject = {
  [actionType.REQUEST_SUCCESS]:
  (state: ReadHostState = ReadHostDefaultState, action: Action<InfraHost>):
    ReadHostState => {
    return {
      ...state,
      host: <InfraHost>action.payload,
    };
  },
  [actionType.REQUEST_FAILURE]:
  (state: ReadHostState = ReadHostDefaultState, action: Action<Error>):
    ReadHostState => {
    return state;
  },
};

export default reducer;
