import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import InfraMachine from '@overflow/infra/api/model/InfraMachine';

import * as actionType from '../action/machine_read';
import ReadMachineState, { defaultState as ReadMachineDefaultState } from '../state/MachineRead';

const reducer: ReducersMapObject = {
  [actionType.REQUEST_SUCCESS]:
  (state: ReadMachineState = ReadMachineDefaultState, action: Action<InfraMachine>):
    ReadMachineState => {
    return {
      ...state,
      machine: <InfraMachine>action.payload,
    };
  },
  [actionType.REQUEST_FAILURE]:
  (state: ReadMachineState = ReadMachineDefaultState, action: Action<Error>):
    ReadMachineState => {
    return state;
  },
};

export default reducer;
