import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import InfraOSApplication from '@overflow/infra/api/model/InfraOSApplication';

import * as actionType from '../action/os_application_read';
import ReadOSAppplicationState, { defaultState as ReadOSApplicationDefaultState } from '../state/OSApplicationRead';

const reducer: ReducersMapObject = {
    [actionType.REQUEST_SUCCESS]:
    (state: ReadOSAppplicationState = ReadOSApplicationDefaultState, action: Action<InfraOSApplication>):
        ReadOSAppplicationState => {
        return {
            ...state,
            osApplication: <InfraOSApplication>action.payload,
        };
    },
    [actionType.REQUEST_FAILURE]:
    (state: ReadOSAppplicationState = ReadOSApplicationDefaultState, action: Action<Error>):
        ReadOSAppplicationState => {
        return state;
    },
};

export default reducer;
