import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import InfraOSDaemon from '@overflow/infra/api/model/InfraOSDaemon';

import * as actionType from '../action/os_daemon_read';
import ReadOSDaemonState, { defaultState as ReadOSDaemonDefaultState } from '../state/OSDaemonRead';

const reducer: ReducersMapObject = {
    [actionType.REQUEST_SUCCESS]:
    (state: ReadOSDaemonState = ReadOSDaemonDefaultState, action: Action<InfraOSDaemon>):
        ReadOSDaemonState => {
        return {
            ...state,
            osDaemon: <InfraOSDaemon>action.payload,
        };
    },
    [actionType.REQUEST_FAILURE]:
    (state: ReadOSDaemonState = ReadOSDaemonDefaultState, action: Action<Error>):
        ReadOSDaemonState => {
        return state;
    },
};

export default reducer;
