import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import InfraOSPort from '@overflow/infra/api/model/InfraOSPort';

import * as actionType from '../action/os_port_read';
import ReadOSPortState, { defaultState as ReadOSPortDefaultState } from '../state/OSPortRead';

const reducer: ReducersMapObject = {
    [actionType.REQUEST_SUCCESS]:
    (state: ReadOSPortState = ReadOSPortDefaultState, action: Action<InfraOSPort>):
        ReadOSPortState => {
        return {
            ...state,
            osPort: <InfraOSPort>action.payload,
        };
    },
    [actionType.REQUEST_FAILURE]:
    (state: ReadOSPortState = ReadOSPortDefaultState, action: Action<Error>):
        ReadOSPortState => {
        return state;
    },
};

export default reducer;
