import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import InfraOS from '@overflow/infra/api/model/InfraOS';

import * as actionType from '../action/os_read';
import ReadOSState, { defaultState as ReadOSDefaultState } from '../state/OSRead';

const reducer: ReducersMapObject = {
    [actionType.REQUEST_SUCCESS]:
    (state: ReadOSState = ReadOSDefaultState, action: Action<InfraOS>):
        ReadOSState => {
        return {
            ...state,
            os: <InfraOS>action.payload,
        };
    },
    [actionType.REQUEST_FAILURE]:
    (state: ReadOSState = ReadOSDefaultState, action: Action<Error>):
        ReadOSState => {
        return state;
    },
};

export default reducer;
