import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import InfraService from '@overflow/infra/api/model/InfraService';

import * as actionType from '../action/service_read';
import ReadServiceState, { defaultState as ReadServiceDefaultState } from '../state/ServiceRead';

const reducer: ReducersMapObject = {
    [actionType.REQUEST_SUCCESS]:
    (state: ReadServiceState = ReadServiceDefaultState, action: Action<InfraService>):
        ReadServiceState => {
        return {
            ...state,
            service: <InfraService>action.payload,
        };
    },
    [actionType.REQUEST_FAILURE]:
    (state: ReadServiceState = ReadServiceDefaultState, action: Action<Error>):
        ReadServiceState => {
        return state;
    },
};

export default reducer;
