import { connect, Dispatch } from 'react-redux';
import Member from '../api/model/Member';

import {
  Modify,
  StateProps as ModifyStateProps,
  DispatchProps as ModifyDispatchProps,
} from './components/Modify';
import State from '../redux/state/Modify';

import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
import { push as routerPush } from 'react-router-redux';
import * as modifyActions from '../redux/action/modify';
import * as readActions from '../redux/action/read';


export function mapStateToProps(state: State, ownProps?:ModifyStateProps): ModifyStateProps {
  return {
    member: state.member,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): ModifyDispatchProps {
  return {
    onModify: (member: Member, pw: string) => {
      dispatch(asyncRequestActions.request('MemberService', 'modify', modifyActions.REQUEST, JSON.stringify(member), pw));
    },
    onReadMember: (id: number) => {
      dispatch(asyncRequestActions.request('MemberService', 'read', readActions.REQUEST, JSON.stringify(id)));
    },
    onRedirectHome: () => {
      dispatch(routerPush('/'));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(Modify);
