import *as React from 'react';
import {
  Input,
  InputOnChangeData,
  Button,
  Form,
  ButtonProps,
} from 'semantic-ui-react';

export interface StateProps {
}

export interface DispatchProps {
  onResetPassword?(pass:string):void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  pass: string;
  passCon: string;
}

export class PWChange extends React.Component<Props, State> {
  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      pass:null,
      passCon:null,
    };

  }

  public render(): JSX.Element {
    return (
      <Form>
        <Form.Input placeholder='Password' type='password' onChange={
          (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
            this.setState({ pass: data.value });
          }} />
        <Form.Input placeholder='Password Confirm' type='password' onChange={
          (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
            this.setState({ passCon: data.value });
          }} />
        <Form.Group>
          <Button primary fluid style={{margin:'7'}} onClick={this.passChangeClick}>    Submit  </Button>
          <Button fluid style={{margin:'7'}}>    Cancel  </Button>
        </Form.Group>
      </Form>
    );
  }

  private passChangeClick(event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps):void {
    this.props.onResetPassword(this.state.pass);
  }
}

