import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Member from '@overflow/member/api/model/Member';

import * as PWConfirmActionTypes from '../action/signIn';
import PWConfirmState, { defaultState as pwConfirmDefaultState } from '../state/PWConfirm';

const reducer: ReducersMapObject = {
  [PWConfirmActionTypes.REQUEST_SUCCESS]: (state: PWConfirmState = pwConfirmDefaultState, action: Action<Member>): PWConfirmState => {
    return {
      ...state,
      isPWConfirm: true,
    };
  },
  [PWConfirmActionTypes.REQUEST_FAILURE]: (state: PWConfirmState = pwConfirmDefaultState, action: Action<Error>): PWConfirmState => {
    if (action.error.name === 'SignInPwNotMatchException') {
      //
    }
    return {
      ...state,
      error: new Error(action.error.name),
    };
  },
};

export default reducer;
