import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Member from '@overflow/member/api/model/Member';

import * as SigninActionTypes from '../action/signIn';
import SigninState, { defaultState as signinDefaultState } from '../state/SignIn';

const reducer: ReducersMapObject = {
  [SigninActionTypes.REQUEST_SUCCESS]: (state: SigninState = signinDefaultState, action: Action<Member>): SigninState => {
    return {
      ...state,
      isAuthenticated: true,
    };
  },
  [SigninActionTypes.REQUEST_FAILURE]: (state: SigninState = signinDefaultState, action: Action<Error>): SigninState => {
    if (action.error.name === 'SignInPwNotMatchException') {
      //
    }
    return {
      ...state,
      error: new Error('SigninIdPwNotMatch'),
    };
  },
};

export default reducer;
