import { connect, Dispatch } from 'react-redux';
import {
  CrawlerSelector,
  CrawlerSelectorStateProps,
  CrawlerSelectorDispatchProps,
} from './components/CrawlerSelector';
// import State from '../redux/state/ReadAllByTarget';

import Target from '@overflow/target/api/model/Target';
import MetaCrawler from '@overflow/meta/api/model/MetaCrawler';
// import Sensor from '@overflow/sensor/api/model/Sensor';
// import MetaSensorItem from '@overflow/meta/api/model/MetaSensorItem';

import * as CrawlerReadAllByTargetActions from '@overflow/meta/redux/action/crawler_read_all_by_target';
// import * as SensorItemReadAllActions from '@overflow/meta/redux/action/sensor_item_read_all';
// import * as CrawlerReadAllByTargetActions from '../redux/action/crawler_read_all_by_target';
import * as CrawlerAuthInputsActions from '@overflow/meta/redux/action/crawler_auth_inputs';

import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

// FIXME::....

export function mapStateToProps(state: any, props: any): CrawlerSelectorStateProps {
  return {
    metaCralwerList: state.MetaCrawlerList,
     metaCrawlerInputItemList:state.MetaCrawlerInputItemList,
     onSelectCrawlerId: props.onSelectCrawlerId,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): CrawlerSelectorDispatchProps {
  return {
    onCrawlerReadAllByTarget: (target: Target) => {
      dispatch(asyncRequestActions.request('MetaCrawlerService', 'readAll', CrawlerReadAllByTargetActions.REQUEST));
    },
    onCrawlerReadAllByMetaCrawler: (crawler: MetaCrawler) => {
      dispatch(asyncRequestActions.request('MetaCrawlerInputItemService',
                                           'readAllByMetaCrawler', CrawlerAuthInputsActions.REQUEST, JSON.stringify(crawler)));
    },
    // onCheckCrawlerAuth: (authInfo: string) => {
    //   // dispatch(ReadActions.request(id));
    // },
    // // FIXME::how to sensor item?
    // onReadMetaSensorItem: () => {
    //   dispatch(SensorItemReadAllActions.request());
    // },
    // onSaveSensor: (sensor: Sensor) => {
    //   dispatch(RegistActions.request(sensor));
    // },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(CrawlerSelector);
