
import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import SensorItem from '@overflow/sensor/api/model/SensorItem';

import * as SensorItemReadAllBySensorActions from '../action/sensor_item_read_all_by_sensor';
import SensorItemReadAllBySensorState, { defaultState as SensorItemReadAllBySensorDefaultState } from '../state/SensorItemReadAllBySensor';

import MetaCrawler from '../../api/model/MetaCrawler';

const reducer: ReducersMapObject = {
  [SensorItemReadAllBySensorActions.REQUEST_SUCCESS]:
  (state: SensorItemReadAllBySensorState = SensorItemReadAllBySensorDefaultState, action: Action<SensorItem[]>):
   SensorItemReadAllBySensorState => {
    console.log(action);
    return {
      ...state,
      SensorItemList: <SensorItem[]>action.payload,
    };
  },
  [SensorItemReadAllBySensorActions.REQUEST_FAILURE]:
  (state: SensorItemReadAllBySensorState = SensorItemReadAllBySensorDefaultState, action: Action<Error>):
   SensorItemReadAllBySensorState => {
    return state;
  },
};

export default reducer;
