import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import NoAuthProbe from '@overflow/noauthprobe/api/model/NoAuthProbe';

import * as AcceptActionTypes from '../action/accept';
import AcceptState, { defaultState as acceptDefaultState } from '../state/Accept';

const reducer: ReducersMapObject = {
  [AcceptActionTypes.REQUEST_SUCCESS]:
    (state: AcceptState = acceptDefaultState, action: Action<NoAuthProbe>):
      AcceptState => {
      return {
        ...state,
        noauthList: <NoAuthProbe[]>action.payload,
      };
    },
  [AcceptActionTypes.REQUEST_FAILURE]:
    (state: AcceptState = acceptDefaultState, action: Action<Error>):
      AcceptState => {
      return state;
    },
};

export default reducer;
