import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import NoAuthProbe from '@overflow/noauthprobe/api/model/NoAuthProbe';

import * as DenyActionTypes from '../action/deny';
import DenyState, { defaultState as denyDefaultState } from '../state/Deny';

const reducer: ReducersMapObject = {
  [DenyActionTypes.REQUEST_SUCCESS]:
    (state: DenyState = denyDefaultState, action: Action<NoAuthProbe>):
      DenyState => {
      return {
        ...state,
        noauthList: <NoAuthProbe[]>action.payload,
      };
    },
  [DenyActionTypes.REQUEST_FAILURE]:
    (state: DenyState = denyDefaultState, action: Action<Error>):
      DenyState => {
      return state;
    },
};

export default reducer;
