import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import NoAuthProbe from '@overflow/noauthprobe/api/model/NoAuthProbe';

import * as ReadAllByDomainActionTypes from '../action/read_all_by_domain';
import ReadAllNoAuthProbeByDomainState, { defaultState as readAllNoAuthProbeByDomainDefaultState } from '../state/ReadAllByDomain';

const reducer: ReducersMapObject = {
  [ReadAllByDomainActionTypes.REQUEST_SUCCESS]:
    (state: ReadAllNoAuthProbeByDomainState = readAllNoAuthProbeByDomainDefaultState, action: Action<NoAuthProbe>):
      ReadAllNoAuthProbeByDomainState => {
      return {
        ...state,
        noauthList: <NoAuthProbe[]>action.payload,
      };
    },
  [ReadAllByDomainActionTypes.REQUEST_FAILURE]:
    (state: ReadAllNoAuthProbeByDomainState = readAllNoAuthProbeByDomainDefaultState, action: Action<Error>):
      ReadAllNoAuthProbeByDomainState => {
      return state;
    },
};

export default reducer;
