import { connect, Dispatch } from 'react-redux';
import {
    ProbeHost,
    StateProps as ProbeDetailStateProps,
    DispatchProps as ProbeDetailDispatchProps,
} from './components/ProbeHost';
import { push as routerPush } from 'react-router-redux';
import Probe from '@overflow/probe/api/model/Probe';
import * as probeReadActions from '../redux/action/read';
import * as probeHostReadByProbeActions from '../redux/action/host_read_by_probe';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

export function mapStateToProps(state: any, props: any): ProbeDetailStateProps {
    return {
        id: props.params.id,
        probe: state.probe,
        probeHost: state.probeHost,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): ProbeDetailDispatchProps {
    return {
        onRead: (id: string) => {
            dispatch(asyncRequestActions.request('ProbeService', 'read', probeReadActions.REQUEST, id));
        },
        onHostReadByProbe: (probe: Probe) => {
            dispatch(asyncRequestActions.request('ProbeHostService', 'readByProbe',
                                                 probeHostReadByProbeActions.REQUEST, JSON.stringify(probe)));
        },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(ProbeHost);
