import { connect, Dispatch } from 'react-redux';
import {
    ProbeList,
    StateProps as ProbeListStateProps,
    DispatchProps as ProbeListDispatchProps,
} from './components/ProbeList';

import Domain from '@overflow/domain/api/model/Domain';
import * as probeListActions from '../redux/action/read_all_by_domain';
import { push as routerPush } from 'react-router-redux';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

export function mapStateToProps(state: any): ProbeListStateProps {
    return {
        probeList: state.probeList,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): ProbeListDispatchProps {
    return {
        onReadAllByDomain: (domain: Domain) => {
            dispatch(asyncRequestActions.request('ProbeService', 'readAllByDomain', probeListActions.REQUEST, JSON.stringify(domain)));
        },
        onProbeSelection: (id: string) => {
            dispatch(routerPush('/probe/' + id));
        },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(ProbeList);
