import *as React from 'react';
import {
  Grid,
  Menu,
  Segment,
  MenuItemProps,
  Container,
  Icon,
} from 'semantic-ui-react';

export interface StateProps {

}

export interface DispatchProps {

}

export type Props = StateProps & DispatchProps;

export interface State {
  activeItem: string;
}

const osNames = [
  {
    'name': 'Windows',
    'icon': 'windows',
  },
  {
    'name': 'Ubuntu',
    'icon': 'linux',
  },
  {
    'name': 'Fedora',
    'icon': 'linux',
  },
  {
    'name': 'CentOS',
    'icon': 'linux',
  },
];

export class ProbeDown extends React.Component<any, any> {
  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      activeItem: '',
    };
  }

  public handleItemClick = (event: React.SyntheticEvent<HTMLAnchorElement>, data: MenuItemProps): void => {
    this.setState({ activeItem: data.name });
  }

  public ShowContent = (): JSX.Element => {
    let os = this.state.activeItem;
    if(os === '') {
      return <div>Instruction page.</div>;
    }
    switch (os) {
      case 'Windows': {
        return <Windows />;
      }
      case 'Ubuntu': {
        return <Ubuntu />;
      }
      case 'Fedora': {
        return <Fedora />;
      }
      case 'CentOS': {
        return <CentOS />;
      }
      default:
        break;
    }
    return null;
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Grid>
          <Grid.Column width={4}>
            <Menu fluid vertical icon='labeled' pointing>
              {osNames.map((item: any, index: number) => {
                return (
                  <Menu.Item key={index} name={item.name} active={this.state.activeItem === item.name} onClick={this.handleItemClick} >
                    <Icon name={item.icon} />
                    {item.name}
                  </Menu.Item>
                );
              })}
            </Menu>
          </Grid.Column>

          <Grid.Column stretched width={12}>
            <Segment>
              {this.ShowContent()}
            </Segment>
          </Grid.Column>
        </Grid>
      </Container>
    );
  }
}

export class Windows extends React.Component<any, any> {
  constructor(props: Props, context: State) {
    super(props, context);
  }

  public render(): JSX.Element {
    return (
      <div>
        Windows Download Page
      </div>
    );
  }
}

export class Ubuntu extends React.Component<any, any> {
  constructor(props: Props, context: State) {
    super(props, context);
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        Ubuntu Download Page
      </Container>
    );
  }
}

export class Fedora extends React.Component<any, any> {
  constructor(props: Props, context: State) {
    super(props, context);
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        Fedora Download Page
      </Container>
    );
  }
}

export class CentOS extends React.Component<any, any> {
  constructor(props: Props, context: State) {
    super(props, context);
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        CentOS Download Page
      </Container>
    );
  }
}
