import Action from '@overflow/commons/redux/Action';
import Probe from '../../api/model/Probe';
import RegistPayload from '../payload/RegistPayload';

// Action Type
export type REQUEST = '@overflow/probe/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/probe/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/probe/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/probe/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/probe/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/probe/regist/REQUEST_FAILURE';

// Action Creater
export type request = (probe: Probe) => Action<RegistPayload>;
export type requestSuccess = (probe: Probe) => Action<Probe>;
export type requestFailure = (error: Error) => Action;



export const request: request = (probe: Probe): Action<RegistPayload> => {
  return {
    type: REQUEST,
    payload: {
      probe: probe,
    },
  };
};

export const requestSuccess: requestSuccess = (probe: Probe): Action<Probe> => {
  return {
    type: REQUEST_SUCCESS,
    payload: probe,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
