import Action from '@overflow/commons/redux/Action';
import Probe from '../../api/model/Probe';
import ProbeTask from '../../api/model/ProbeTask';
import TaskReadAllByProbePayload from '../payload/TaskReadAllByProbePayload';

// Action Type
export type REQUEST = '@overflow/probe/task_read_all_by_probe/REQUEST';
export type REQUEST_SUCCESS = '@overflow/probe/task_read_all_by_probe/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/probe/task_read_all_by_probe/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/probe/task_read_all_by_probe/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/probe/task_read_all_by_probe/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/probe/task_read_all_by_probe/REQUEST_FAILURE';

// Action Creater
export type request = (probe: Probe) => Action<TaskReadAllByProbePayload>;
export type requestSuccess = (probeTasks: ProbeTask[]) => Action<ProbeTask[]>;
export type requestFailure = (error: Error) => Action;

export const request: request = (probe: Probe): Action<TaskReadAllByProbePayload> => {
  return {
    type: REQUEST,
    payload: {
      probe: probe,
    },
  };
};

export const requestSuccess: requestSuccess = (probeTasks: ProbeTask[]): Action<ProbeTask[]> => {
  return {
    type: REQUEST_SUCCESS,
    payload: probeTasks,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
