import Action from '@overflow/commons/redux/Action';
import ProbeTask from '../../api/model/ProbeTask';
import TaskRegistPayload from '../payload/TaskRegistPayload';

// Action Type
export type REQUEST = '@overflow/probe/task_regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/probe/task_regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/probe/task_regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/probe/task_regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/probe/task_regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/probe/task_regist/REQUEST_FAILURE';

// Action Creater
export type request = (probeTask: ProbeTask) => Action<TaskRegistPayload>;
export type requestSuccess = (probeTask: ProbeTask) => Action<ProbeTask>;
export type requestFailure = (error: Error) => Action;



export const request: request = (probeTask: ProbeTask): Action<TaskRegistPayload> => {
  return {
    type: REQUEST,
    payload: {
      probeTask: probeTask,
    },
  };
};

export const requestSuccess: requestSuccess = (probeTask: ProbeTask): Action<ProbeTask> => {
  return {
    type: REQUEST_SUCCESS,
    payload: probeTask,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
