import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Probe from '@overflow/probe/api/model/Probe';
import ProbeHost from '@overflow/probe/api/model/ProbeHost';

import * as HostReadByProbeActionTypes from '../action/host_read_by_probe';
import HostReadByProbeState, { defaultState as hostReadByProbeDefaultState } from '../state/HostReadByProbe';

const reducer: ReducersMapObject = {
  [HostReadByProbeActionTypes.REQUEST_SUCCESS]:
  (state: HostReadByProbeState = hostReadByProbeDefaultState, action: Action<ProbeHost>):
  HostReadByProbeState => {
      return {
      ...state,
      probeHost: <ProbeHost>action.payload,
    };
  },
  [HostReadByProbeActionTypes.REQUEST_FAILURE]:
  (state: HostReadByProbeState = hostReadByProbeDefaultState, action: Action<Error>):
  HostReadByProbeState => {
    return state;
  },
};

export default reducer;
