import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Probe from '@overflow/probe/api/model/Probe';

import * as ModifyActionTypes from '../action/modify';
import ModifyState, { defaultState as modifyDefaultState } from '../state/Modify';

const reducer: ReducersMapObject = {
  [ModifyActionTypes.REQUEST_SUCCESS]:
  (state: ModifyState = modifyDefaultState, action: Action<Probe>):
  ModifyState => {
      return {
      ...state,
      probe: <Probe>action.payload,
    };
  },
  [ModifyActionTypes.REQUEST_FAILURE]:
  (state: ModifyState = modifyDefaultState, action: Action<Error>):
  ModifyState => {
    return state;
  },
};

export default reducer;
