import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Probe from '@overflow/probe/api/model/Probe';

import * as ReadActionTypes from '../action/read';
import ReadState, { defaultState as readDefaultState } from '../state/Read';

const reducer: ReducersMapObject = {
  [ReadActionTypes.REQUEST_SUCCESS]:
  (state: ReadState = readDefaultState, action: Action<Probe>):
  ReadState => {
      return {
      ...state,
      probe: <Probe>action.payload,
    };
  },
  [ReadActionTypes.REQUEST_FAILURE]:
  (state: ReadState = readDefaultState, action: Action<Error>):
  ReadState => {
    return state;
  },
};

export default reducer;
