import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Probe from '@overflow/probe/api/model/Probe';

import * as ReadAllByDomainActionTypes from '../action/read_all_by_domain';
import ReadAllByDomainState, { defaultState as ReadAllByDomainDefaultState } from '../state/ReadAllByDomain';

const reducer: ReducersMapObject = {
  [ReadAllByDomainActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllByDomainState = ReadAllByDomainDefaultState, action: Action<Probe>):
    ReadAllByDomainState => {
    return {
      ...state,
      probeList: <Probe[]>action.payload,
    };
  },
  [ReadAllByDomainActionTypes.REQUEST_FAILURE]:
  (state: ReadAllByDomainState = ReadAllByDomainDefaultState, action: Action<Error>):
    ReadAllByDomainState => {
    return state;
  },
};

export default reducer;
