import { connect, Dispatch } from 'react-redux';
import {
  SensorDetailItems,
  StateProps as SensorDetailItemsStateProps,
  DispatchProps as SensorDetailItemsDispatchProps,
} from './components/SensorDetailItems';
import State from '../redux/state/ItemRead';

import Sensor from '@overflow/sensor/api/model/Sensor';

import * as ItemReadAllBySensorActions from '../redux/action/item_read_all_by_sensor';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';
export function mapStateToProps(state: any, props: any): SensorDetailItemsStateProps {
  return {
    sensorId: props.params.id,
    sensorItemList: state.SensorItemList,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): SensorDetailItemsDispatchProps {
  return {
    onReadAllBySensor: (sensor: Sensor) => {
      dispatch(asyncRequestActions.request('SensorItemService', 'readAllBySensor',
                                           ItemReadAllBySensorActions.REQUEST, JSON.stringify(sensor)));
    },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(SensorDetailItems);
