import * as React from 'react';
import { Table, Button, Header, Container } from 'semantic-ui-react';

import Sensor from '@overflow/sensor/api/model/Sensor';
import SensorItem from '@overflow/sensor/api/model/SensorItem';

export interface StateProps {
  sensorId?: number;
  sensorItemList?: SensorItem[];
}

export interface DispatchProps {
  onReadAllBySensor?(sensor: Sensor): void;
}

export type Props = StateProps & DispatchProps;

export interface State {

}


export class SensorDetailItems extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      // sensorItemList: SensorItemJson,
    };

    this.props.onReadAllBySensor({id: this.props.sensorId});

  }

  public componentWillMount(): void {
    console.log('');
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Table celled>
          <Table.Header>
            <Table.Row>
              <Table.HeaderCell>No.</Table.HeaderCell>
              <Table.HeaderCell>Type</Table.HeaderCell>
              <Table.HeaderCell>Name</Table.HeaderCell>
              <Table.HeaderCell>Key</Table.HeaderCell>
            </Table.Row>
          </Table.Header>

          <Table.Body>
            {
              this.props.sensorItemList ? this.props.sensorItemList.map((sensorItem: SensorItem, idx: number) => {
                return (
                  <Table.Row key={idx}>
                    <Table.Cell>{idx}</Table.Cell>
                    <Table.Cell>{sensorItem.item.itemType.name}</Table.Cell>
                    <Table.Cell>{sensorItem.item.name}</Table.Cell>
                    <Table.Cell>{sensorItem.item.key}</Table.Cell>
                  </Table.Row>
                );
              }) : ''
            }
          </Table.Body>

        </Table>
      </Container>
    );
  }
}



// const SensorItemJson: any = [{
//   'id': 1,
//   'sensor': {
//     'id': 1,
//     'createDate': 1498475947009,
//     'description': 'My sensor',
//     'status': {
//       'id': 1,
//       'name': 'RUNNING',
//     },
//     'target': {
//       'id': 1,
//       'createDate': 1501154289555,
//       'displayName': 'ghost target',
//       'description': 'i am target',
//     },
//     'crawler': {
//       'id': 1,
//       'createDate': 1498794968791,
//       'name': 'ACTIVEDIRECTORY_CRAWLER',
//       'description': 'ACTIVEDIRECTORY',
//     },
//     'crawlerInputItems': null,
//   },
//   'item': {
//     'id': 1,
//     'itemType': {
//       'id': 1,
//       'name': 'CPU',
//       'description': 'CPU blah blah blah',
//       'createDate': 1498474179690,
//     },
//     'key': 'cpu.usage',
//     'name': 'CPU USAGE',
//     'createDate': 1498475408269,
//   },
//   'createDate': 1498476076626,
// },
// {
//   'id': 2,
//   'sensor': {
//     'id': 1,
//     'createDate': 1498475947074,
//     'description': 'My sensor',
//     'status': {
//       'id': 1,
//       'name': 'RUNNING',
//     },
//     'target': {
//       'id': 1,
//       'createDate': 1501154289555,
//       'displayName': 'ghost target',
//       'description': 'i am target',
//     },
//     'crawler': {
//       'id': 1,
//       'createDate': 1498794968791,
//       'name': 'ACTIVEDIRECTORY_CRAWLER',
//       'description': 'ACTIVEDIRECTORY',
//     },
//     'crawlerInputItems': null,
//   },
//   'item': {
//     'id': 2,
//     'itemType': {
//       'id': 1,
//       'name': 'CPU',
//       'description': 'CPU blah blah blah',
//       'createDate': 1498474179690,
//     },
//     'key': 'cpu.free',
//     'name': 'CPU FREE',
//     'createDate': 1498475408361,
//   },
//   'createDate': 1498476110988,
// },
// ];
