import Action from '@overflow/commons/redux/Action';
import SensorItem from '../../api/model/SensorItem';
import ItemRegistPayload from '../payload/ItemRegistPayload';

// Action Type
export type REQUEST = '@overflow/sensor_item/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/sensor_item/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/sensor_item/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/sensor_item/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/sensor_item/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/sensor_item/regist/REQUEST_FAILURE';

// Action Creater
export type request = (sensorItem: SensorItem) => Action<ItemRegistPayload>;
export type requestSuccess = (sensorItem: SensorItem) => Action<SensorItem>;
export type requestFailure = (error: Error) => Action;



export const request: request = (sensorItem: SensorItem): Action<ItemRegistPayload> => {
  return {
    type: REQUEST,
    payload: {
      sensorItem: sensorItem,
    },
  };
};

export const requestSuccess: requestSuccess = (sensorItem: SensorItem): Action<SensorItem> => {
  return {
    type: REQUEST_SUCCESS,
    payload: sensorItem,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
