import Action from '@overflow/commons/redux/Action';
import SensorItem from '../../api/model/SensorItem';
import ItemRemovePayload from '../payload/ItemRemovePayload';

// Action Type
export type REQUEST = '@overflow/sensor_item/remove/REQUEST';
export type REQUEST_SUCCESS = '@overflow/sensor_item/remove/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/sensor_item/remove/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/sensor_item/remove/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/sensor_item/remove/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/sensor_item/remove/REQUEST_FAILURE';

// Action Creater
export type request = (sensorItem: SensorItem) => Action<ItemRemovePayload>;
export type requestSuccess = () => Action<void>;
export type requestFailure = (error: Error) => Action;



export const request: request = (sensorItem: SensorItem): Action<ItemRemovePayload> => {
  return {
    type: REQUEST,
    payload: {
      sensorItem: sensorItem,
    },
  };
};

export const requestSuccess: requestSuccess = (): Action<void> => {
  return {
    type: REQUEST_SUCCESS,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
