import Action from '@overflow/commons/redux/Action';
import Sensor from '../../api/model/Sensor';
import ReadAllByProbePayload from '../payload/ReadAllByProbePayload';
import Probe from '@overflow/probe/api/model/Probe';

// Action Type
export type REQUEST = '@overflow/sensor/read_all_by_probe/REQUEST';
export type REQUEST_SUCCESS = '@overflow/sensor/read_all_by_probe/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/sensor/read_all_by_probe/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/sensor/read_all_by_probe/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/sensor/read_all_by_probe/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/sensor/read_all_by_probe/REQUEST_FAILURE';

// Action Creater
export type request = (probe: Probe) => Action<ReadAllByProbePayload>;
export type requestSuccess = (sensors: Sensor[]) => Action<Sensor[]>;
export type requestFailure = (error: Error) => Action;



export const request: request = (probe: Probe): Action<ReadAllByProbePayload> => {
  return {
    type: REQUEST,
    payload: {
      probe: probe,
    },
  };
};

export const requestSuccess: requestSuccess = (sensors: Sensor[]): Action<Sensor[]> => {
  return {
    type: REQUEST_SUCCESS,
    payload: sensors,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
