import Action from '@overflow/commons/redux/Action';
import Sensor from '../../api/model/Sensor';
import RegistPayload from '../payload/RegistPayload';

// Action Type
export type REQUEST = '@overflow/sensor/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/sensor/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/sensor/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/sensor/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/sensor/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/sensor/regist/REQUEST_FAILURE';

// Action Creater
export type request = (sensor: Sensor) => Action<RegistPayload>;
export type requestSuccess = (sensor: Sensor) => Action<Sensor>;
export type requestFailure = (error: Error) => Action;



export const request: request = (sensor: Sensor): Action<RegistPayload> => {
  return {
    type: REQUEST,
    payload: {
      sensor: sensor,
    },
  };
};

export const requestSuccess: requestSuccess = (sensor: Sensor): Action<Sensor> => {
  return {
    type: REQUEST_SUCCESS,
    payload: sensor,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
