import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Sensor from '@overflow/sensor/api/model/Sensor';

import * as ReadAllByDomainActionTypes from '../action/read_all_by_domain';
import ReadAllByDomain, { defaultState as readAllByDomainDefaultState } from '../state/ReadAllByDomain';

const reducer: ReducersMapObject = {
  [ReadAllByDomainActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllByDomain = readAllByDomainDefaultState, action: Action<Sensor[]>):
  ReadAllByDomain => {
     return {
      ...state,
      SensorList:<Sensor[]>action.payload,
    };
  },
  [ReadAllByDomainActionTypes.REQUEST_FAILURE]:
  (state: ReadAllByDomain = readAllByDomainDefaultState, action: Action<Error>):
  ReadAllByDomain => {
    return state;
  },
};

export default reducer;
