/**
 * Created by geek on 17. 7. 3.
 */

import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Sensor from '@overflow/sensor/api/model/Sensor';

import * as ReadAllByTargetActionTypes from '../action/read_all_by_target';
import ReadAllByTargetState, { defaultState as readAllByTargetDefaultState } from '../state/ReadAllByTarget';

const reducer: ReducersMapObject = {
  [ReadAllByTargetActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllByTargetState = readAllByTargetDefaultState, action: Action<Sensor>): ReadAllByTargetState => {
    console.log(action);
    return {
      ...state,
      SensorList:<Sensor[]>action.payload,
    };
  },
  [ReadAllByTargetActionTypes.REQUEST_FAILURE]:
  (state: ReadAllByTargetState = readAllByTargetDefaultState, action: Action<Error>):
  ReadAllByTargetState => {
    return state;
  },
};

export default reducer;
