import { connect, Dispatch } from 'react-redux';
import {
    TargetDetail,
    StateProps as StateProps,
    DispatchProps as DispatchProps,
    Props as Props,
} from './components/TargetDetail';

import * as targetDetailActions from '../redux/action/read';


import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

export function mapStateToProps(state: any, props: any): StateProps {
    return {
        id: props.params.id,
        infra: state.infra,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
    return {
        onRead: (id: string) => {
            dispatch(asyncRequestActions.request('InfraService', 'read', targetDetailActions.REQUEST, id));
        },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(TargetDetail);
