import * as React from 'react';
import { Button, Table, Header, Container } from 'semantic-ui-react';
import { DetailContainer } from '@overflow/commons/react/component/DetailContainer';
import Infra from '@overflow/infra/api/model/Infra';
import InfraHost from '@overflow/infra/api/model/InfraHost';
import InfraMachine from '@overflow/infra/api/model/InfraMachine';
import InfraOS from '@overflow/infra/api/model/InfraOS';
import InfraOSApplication from '@overflow/infra/api/model/InfraOSApplication';
import InfraOSDaemon from '@overflow/infra/api/model/InfraOSDaemon';
import InfraOSPort from '@overflow/infra/api/model/InfraOSPort';
import InfraService from '@overflow/infra/api/model/InfraService';


import * as Utils from '@overflow/commons/util/Utils';

export interface StateProps {
  // infraId?: number;
  infra: Infra;
  // machine?: InfraMachine;
  // host?: InfraHost;
  // os?: InfraOS;
  // osApplication?: InfraOSApplication;
  // osDaemon?: InfraOSDaemon;
  // osPort?: InfraOSPort;
  // service?: InfraService;
}

export interface DispatchProps {
  // onReadInfraMachine?(id: string): void;
  // onReadInfraHost?(id: string): void;
  // onReadInfraOS?(id: string): void;
  // onReadInfraOSApplication?(id: string): void;
  // onReadInfraOSDaemon?(id: string): void;
  // onReadInfraOSPort?(id: string): void;
  // onReadInfraService?(id: string): void;
}

export type Props = StateProps & DispatchProps;

export interface State {
}


export class TargetChild extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
    };
    // if (this.props.infra !== undefined && this.props.infra.id === this.props.infraId) {
    //   console.log('initninitnitni');
    //   this.getChild(this.props.infra);
    // }
  }

  // public componentWillMount(): void {
  // }

  // public shouldComponentUpdate?(nextProps: any, nextContext: any): boolean {
  //   if(nextProps.infra.id === this.props.infra.id) {
  //     return false;
  //   }
  //   return true;
  // }

  // public componentWillReceiveProps(nextProps: Readonly<Props>, nextContext: Readonly<State>): void {

  //   // if(this.props.infra === undefined) {
  //   //   this.getChild(nextProps.infra);
  //   //   return;
  //   // }

  //   if (nextProps.infra.id !== this.props.infra.id) {
  //     this.getChild(nextProps.infra);
  //   }
  //   // console.log(nextProps);
  //   // console.log(nextContext);
  // }

  // public getChild(infra: Infra): void {
  //   let infraType = infra.infraType.id;
  //   let id = String(infra.childId);
  //   console.log('getting infra child of ' + this.props.infra.id);
  //   switch (infraType) {
  //     case 1: {
  //       this.props.onReadInfraMachine(id);
  //       break;
  //     }
  //     case 2: {
  //       this.props.onReadInfraHost(id);
  //       break;
  //     }
  //     case 3: {
  //       this.props.onReadInfraOS(id);
  //       break;
  //     }
  //     case 4: {
  //       this.props.onReadInfraOSApplication(id);
  //       break;
  //     }
  //     case 5: {
  //       this.props.onReadInfraOSDaemon(id);
  //       break;
  //     }
  //     case 6: {
  //       this.props.onReadInfraOSPort(id);
  //       break;
  //     }
  //     case 7: {
  //       this.props.onReadInfraService(id);
  //       break;
  //     }
  //     default: {
  //       break;
  //     }
  //   }

  // }

  public render(): JSX.Element {
    if (this.props.infra === undefined) {
      return null;
    }
    return (
      <Container fluid>
        {this.renderInfraChild()}
      </Container>
    );
  }

  public renderInfraChild(): JSX.Element {
    // if (this.props.machine === undefined
    //   && this.props.host === undefined
    //   && this.props.os === undefined
    //   && this.props.osApplication === undefined
    //   && this.props.osDaemon === undefined
    //   && this.props.osPort === undefined
    //   && this.props.service === undefined
    // ) {
    //   return null;
    // }
    let infraType = this.props.infra.infraType.id;
    switch (infraType) {
      case 1: {
        return <InfraTable tableDatas={this.ConvertTableDataForMachine(this.props.infra)} />;
      }
      case 2: {
        return <InfraTable tableDatas={this.ConvertTableDataForHost(this.props.infra)} />;
      }
      case 3: {
        return <InfraTable tableDatas={this.ConvertTableDataForOS(this.props.infra)} />;
      }
      case 4: {
        return <InfraTable tableDatas={this.ConvertTableDataForApplication(this.props.infra)} />;
      }
      case 5: {
        return <InfraTable tableDatas={this.ConvertTableDataForDaemon(this.props.infra)} />;
      }
      case 6: {
        return <InfraTable tableDatas={this.ConvertTableDataForPort(this.props.infra)} />;
      }
      case 7: {
        return <InfraTable tableDatas={this.ConvertTableDataForService(this.props.infra)} />;
      }
      default: {
        break;
      }
    }
  }

  private ConvertTableDataForHost(infraChild: InfraHost): Array<TableData> {
    let NewTableDatas: Array<TableData>;
    NewTableDatas = [{
      header: 'IP',
      contents: Utils.int2ip(infraChild.ip),
    },
    {
      header: 'MAC',
      contents: Utils.intToMac(infraChild.mac),
    },
    ];
    return NewTableDatas;
  }

  private ConvertTableDataForMachine(infraChild: InfraMachine): Array<TableData> {
    let NewTableDatas: Array<TableData>;

    NewTableDatas = [{
      header: 'Meta',
      contents: infraChild.meta,
    },
    ];
    return NewTableDatas;
  }

  private ConvertTableDataForOS(infraChild: InfraOS): Array<TableData> {
    let NewTableDatas: Array<TableData>;
    NewTableDatas = [
      {
        header: 'Meta',
        contents: infraChild.meta,
      },
      {
        header: 'Vendor',
        contents: infraChild.vendor.name,
      },
    ];
    return NewTableDatas;
  }

  private ConvertTableDataForApplication(infraChild: InfraOSApplication): Array<TableData> {
    let NewTableDatas: Array<TableData>;
    NewTableDatas = [
      {
        header: 'Name',
        contents: infraChild.name,
      },
      {
        header: 'OS',
        contents: infraChild.os.vendor.name,
      },
    ];
    return NewTableDatas;
  }
  private ConvertTableDataForDaemon(infraChild: InfraOSDaemon): Array<TableData> {
    let NewTableDatas: Array<TableData>;
    NewTableDatas = [
      {
        header: 'Name',
        contents: infraChild.name,
      },
      {
        header: 'OS',
        contents: infraChild.os.vendor.name,
      },
    ];
    return NewTableDatas;
  }

  private ConvertTableDataForPort(infraChild: InfraOSPort): Array<TableData> {
    let NewTableDatas: Array<TableData>;
    NewTableDatas = [
      {
        header: 'Port',
        contents: infraChild.port,
      },
      {
        header: 'Type',
        contents: infraChild.portType,
      },
      {
        header: 'OS',
        contents: infraChild.os.vendor.name,
      },
    ];
    return NewTableDatas;
  }
  private ConvertTableDataForService(infraChild: InfraService): Array<TableData> {
    let NewTableDatas: Array<TableData>;
    NewTableDatas = [
      {
        header: 'Host',
        contents: Utils.int2ip(infraChild.host.ip),
      },
      {
        header: 'Port',
        contents: infraChild.port,
      },
      {
        header: 'Type',
        contents: infraChild.portType,
      },
      {
        header: 'OS',
        contents: infraChild.host.os.vendor.name,
      },
    ];
    return NewTableDatas;
  }
}

export interface TableData {
  header: string;
  contents: any;
}

export interface InfraTableProps {
  tableDatas: Array<TableData>;
}

export class InfraTable extends React.Component<InfraTableProps, any> {
  constructor(props: InfraTableProps, context: any) {
    super(props, context);
    this.state = {
    };
  }

  public showInfra(): JSX.Element[] {
    let elems: Array<JSX.Element> = new Array();
    let i = 0;
    for (let data of this.props.tableDatas) {
      elems.push(
        <Table.Row key={i++}>
          <Table.Cell collapsing>
            <Header size='small'>{data.header}</Header>
          </Table.Cell>
          <Table.Cell>
            {data.contents}
          </Table.Cell>
        </Table.Row>,
      );
    }

    return elems;
  }

  public render(): JSX.Element {
    return (
      <Table celled={false}>
        <Table.Body>
          {this.showInfra()}
        </Table.Body>
      </Table>
    );
  }
}

export interface TargetBasicInfoProps {
  infra?: Infra;
}

export interface TargetBasicInfoState {
}

export class TargetBasicInfo extends React.Component<TargetBasicInfoProps, TargetBasicInfoState> {

  constructor(props: TargetBasicInfoProps, context: TargetBasicInfoState) {
    super(props, context);
    this.state = {
    };
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Table celled={false}>
          <Table.Body>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Name</Header>
              </Table.Cell>
              <Table.Cell>
                {this.props.infra.target.displayName}
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Description</Header>
              </Table.Cell>
              <Table.Cell>
                {this.props.infra.target.description}
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Sensor Count</Header>
              </Table.Cell>
              <Table.Cell>
                TODO
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Created at</Header>
              </Table.Cell>
              <Table.Cell>
                {Utils.date2date(this.props.infra.target.createDate)}
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Type</Header>
              </Table.Cell>
              <Table.Cell>
                {this.props.infra.infraType.name}
              </Table.Cell>
            </Table.Row>
          </Table.Body>
        </Table>
      </Container>
    );
  }
}
