import * as React from 'react';
import { Button, Table, Header, Container } from 'semantic-ui-react';
import { SensorList } from '@overflow/sensor/react/components/SensorList';
import { DetailContainer } from '@overflow/commons/react/component/DetailContainer';

import Target from '@overflow/target/api/model/Target';


export interface StateProps {
  target: any;
  infra: any;
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  childInfra: any; // todo. fix to InfraTypes
}


export class TargetDetailInfra extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      childInfra: null,
    };
  }

  public componentWillMount(): void {
    // todo. getting infra and child infra

    let child = { // infraHost
      'id': '1',
      'os': {
        'id': '11',
        'machine': {
          'id': '111',
        },
        'meta': 'T ^ T',
        'vendor': {
          'name': 'Loafle',
        },
      },
      'ip': '192.168.1.105',
      'mac': 'ab:12:cd:34:ef:ef',
      'createDate': '2017-01-01',
    };

    this.setState({
      childInfra: child,
    });
  }

  public handleRemoveTarget(): void {
    alert('remove');
  }

  public renderInfra(): JSX.Element {
    let type = this.props.infra.type;
    switch (type) {
      case 'Host': {
        return <InfraHostTable data={this.state.childInfra} />;
      }
      case 'OS': {
        break;
      }
      default:
        break;
    }
    return null;
  }



  public render(): JSX.Element {
    return (
      <Container fluid>
        {this.renderInfra()}
      </Container>
    );
  }
}


export class InfraHostTable extends React.Component<any, any> {
  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }
  public render(): JSX.Element {
    return (
      <Table celled={false}>
        <Table.Body>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>os.vender.name?</Header>
            </Table.Cell>
            <Table.Cell>
              {this.props.data.os.vendor.name}
            </Table.Cell>
          </Table.Row>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>os.meta?</Header>
            </Table.Cell>
            <Table.Cell>
              {this.props.data.os.meta}
            </Table.Cell>
          </Table.Row>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>IP</Header>
            </Table.Cell>
            <Table.Cell>
              {this.props.data.ip}
            </Table.Cell>
          </Table.Row>
          <Table.Row>
            <Table.Cell collapsing>
              <Header size='small'>mac</Header>
            </Table.Cell>
            <Table.Cell>
              {this.props.data.mac}
            </Table.Cell>
          </Table.Row>
        </Table.Body>
      </Table>
    );
  }
}
