import Action from '@overflow/commons/redux/Action';
import Target from '../../api/model/Target';
import RegistPayload from '../payload/RegistPayload';

// Action Type
export type REQUEST = '@overflow/target/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/target/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/target/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/target/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/target/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/target/regist/REQUEST_FAILURE';

// Action Creater
export type request = (target: Target) => Action<RegistPayload>;
export type requestSuccess = (target: Target) => Action<Target>;
export type requestFailure = (error: Error) => Action;



export const request: request = (target: Target): Action<RegistPayload> => {
  return {
    type: REQUEST,
    payload: {
      target: target,
    },
  };
};

export const requestSuccess: requestSuccess = (target: Target): Action<Target> => {
  return {
    type: REQUEST_SUCCESS,
    payload: target,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
