import Action from '@overflow/commons/redux/Action';
import Target from '../../api/model/Target';
import RegistDiscoveredTargetPayload from '../payload/RegistDiscoveredTargetPayload';
import Host from '@overflow/discovery/api/model/Host';
import Probe from '@overflow/probe/api/model/Probe';

// Action Type
export type REQUEST = '@overflow/target/regist_discoved_target/REQUEST';
export type REQUEST_SUCCESS = '@overflow/target/regist_discoved_target/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/target/regist_discoved_target/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/target/regist_discoved_target/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/target/regist_discoved_target/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/target/regist_discoved_target/REQUEST_FAILURE';

// Action Creater
export type request = (hosts: Host[], probe: Probe) => Action<RegistDiscoveredTargetPayload>;
export type requestSuccess = () => Action<void>;
export type requestFailure = (error: Error) => Action;



export const request: request = (hosts: Host[], probe: Probe): Action<RegistDiscoveredTargetPayload> => {
  return {
    type: REQUEST,
    payload: {
      hosts: hosts,
      probe: probe,
    },
  };
};

export const requestSuccess: requestSuccess = (): Action<void> => {
  return {
    type: REQUEST_SUCCESS,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
