import Action from '@overflow/commons/redux/Action';
import Target from '../../api/model/Target';
import RemovePayload from '../payload/RemovePayload';

// Action Type
export type REQUEST = '@overflow/target/remove/REQUEST';
export type REQUEST_SUCCESS = '@overflow/target/remove/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/target/remove/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/target/remove/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/target/remove/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/target/remove/REQUEST_FAILURE';

// Action Creater
export type request = (target: Target) => Action<RemovePayload>;
export type requestSuccess = () => Action<void>;
export type requestFailure = (error: Error) => Action;



export const request: request = (target: Target): Action<RemovePayload> => {
  return {
    type: REQUEST,
    payload: {
      target: target,
    },
  };
};

export const requestSuccess: requestSuccess = (): Action<void> => {
  return {
    type: REQUEST_SUCCESS,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
