import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Infra from '@overflow/infra/api/model/Infra';

import * as ReadAllByProbeActionTypes from '../action/read_all_by_probe';
import ReadAllByProbeState, { defaultState as ReadAllByProbeDefaultState } from '../state/ReadAllByProbe';

const reducer: ReducersMapObject = {
  [ReadAllByProbeActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllByProbeState = ReadAllByProbeDefaultState, action: Action<Infra>):
    ReadAllByProbeState => {
    return {
      ...state,
      infraList: <Infra[]>action.payload,
    };
  },
  [ReadAllByProbeActionTypes.REQUEST_FAILURE]:
  (state: ReadAllByProbeState = ReadAllByProbeDefaultState, action: Action<Infra>):
    ReadAllByProbeState => {
    return state;
  },
};

export default reducer;
