import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Infra from '@overflow/infra/api/model/Infra';

import * as ReadAllByDomainActionTypes from '../action/read_all_by_domain';
import ReadAllByDomainState, { defaultState as ReadAllByDomainDefaultState } from '../state/ReadAllByDomain';

const reducer: ReducersMapObject = {
  [ReadAllByDomainActionTypes.REQUEST_SUCCESS]:
  (state: ReadAllByDomainState = ReadAllByDomainDefaultState, action: Action<Infra>):
    ReadAllByDomainState => {
    return {
      ...state,
      infraList: <Infra[]>action.payload,
    };
  },
  [ReadAllByDomainActionTypes.REQUEST_FAILURE]:
  (state: ReadAllByDomainState = ReadAllByDomainDefaultState, action: Action<Infra>):
    ReadAllByDomainState => {
    return state;
  },
};

export default reducer;
